<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace Geral\Logic\PropostaComercial;

use Windows\WinInt00201000\TabInt00201000011\Facade as Facade011;
use Indeterminado\Entities\Sistprecoprop;
use Indeterminado\Entities\Usuprecoprop;
use Faturamento\Entities\Sistproplinp;
use Faturamento\Entities\Propostalinp;
use Faturamento\Entities\ParGeralFas;
use Geral\Entities\Precoproposta;
use Geral\Entities\Propostafas;
use Geral\Util\DateUtil;
use Setforms2\Shared\Registry;
use TeknisaLib\Config\Config;

/**
 * Description of LinhaProduto
 *
 * @author phillipesilva
 */
class LinhaProduto {
    const PROD_MANUTENCAO = 'M';
    const PROD_LOCACAO    = 'L';
    const PTO_MANUTENCAO  = 'P';
    const PTO_LOCACAO     = 'A';
    
    public static function calculaValoresLinhaProduto($cdPreco, $idTipo, $qtSistemas, $qtUsuarios, $modoProc, 
                                                      $localProc, $idClienProsp, $nrProposta, $nrVersao, $prodComercial)
    {        
        if (($idTipo == 'P') || ($idTipo == 'A')) {
            $nrUsuarios = '1';
        } elseif ($qtUsuarios != '0' && !($qtUsuarios == '')) {
            $nrUsuarios = $qtUsuarios;
        } else {
            $nrUsuarios = '1';
        }

        $cdSegMer  = Propostafas::getRepository()->consultaCdSegMerLinP($nrProposta, $nrVersao, $idClienProsp);
        $tabPrecos = Precoproposta::getRepository()->tabelaPrecos($cdSegMer[0]['CDSEGMER']);
        
        $qtMaxUsuariosRep = Usuprecoprop::getRepository()->getQtdFinUsuarios($cdPreco);
        $qtMaxUsuarios    = $qtMaxUsuariosRep[0]['MAXUSU'];
            
        $qtMaxSistemasRep = Sistprecoprop::getRepository()->getQtdFinSistemas($cdPreco);
        $qtMaxSistemas    = $qtMaxSistemasRep[0]['MAXSISTEMAS'];

        /*
         * Phillipe Silva - 15/07/2014
         * Não terá mais limite de quantidade de usuários nem de sistemas.
         * Conforme conversado com a Fernanda Prado - Contratos.
         */
        $msgFiltroTab = self::filtroTabelaPreco($qtMaxUsuarios, $tabPrecos, $qtSistemas, $cdPreco);
//        $msgFiltroQtd = self::filtroQtdMaxUsuSist($qtSistemas, $nrUsuarios, $qtMaxSistemas, $qtMaxUsuarios);

        if($msgFiltroTab)
        {
            return $msgFiltroTab;
        }
//        if($msgFiltroQtd)
//        {
//            return $msgFiltroQtd;
//        }

        //Passados pelos filtros, inicia-se o CÁLCULO.
        return self::calculaValores($cdPreco, $modoProc, $localProc, $qtSistemas, $qtUsuarios, $idTipo, $nrUsuarios, $prodComercial);
    }
    
    private static function filtroTabelaPreco($qtMaxUsuarios, $tabPrecos, $qtSistemas, $cdPreco)
    {
        if (!$tabPrecos) {
            return tk_get_message_by_name('msg_Linha_Produto_ClienteSemTabelaPreco');
        }
        if (is_null($cdPreco) || $cdPreco == '') {
            return tk_get_message_by_name('msg_Linha_Produto_SelecioneTabelaPreco');
        }
        if (is_null($qtMaxUsuarios) || $qtMaxUsuarios == '') {
            return tk_get_message_by_name('msg_Linha_Produto_ErroTabelaPreco');
        }           
        if ($qtSistemas == '0' || is_null($qtSistemas) || $qtSistemas == '') {
            return tk_get_message_by_name('msg_Linha_Produto_SelecioneSistema');
        }        
        return false;
    }
    
    private static function filtroQtdMaxUsuSist($qtSistemas, $nrUsuarios, $qtMaxSistemas, $qtMaxUsuarios)
    {      
        if ($nrUsuarios > $qtMaxUsuarios) {
            return tk_get_message_by_name('msg_Linha_Produto_QtdUsuariosSuperior');
        }
        if ($qtSistemas > $qtMaxSistemas) {
            return tk_get_message_by_name('msg_Linha_Produto_QtdSistemasSuperior');
        }        
        return false;
    }
    
    private static function calculaValores($cdPreco, $modoProc, $localProc, $qtSistemas, $qtUsuarios, $idTipo, $nrUsuarios, $prodComercial)
    {
        $tabelaPrecos = Precoproposta::getRepository()->getTabelaPrecos($cdPreco);
        $modoLocal    = $modoProc . $localProc;
        $vrPerManuAno = $nrMesPraLoca = $vrUnit = $indice = $descModoLocal = 1;

        //É necessário testar com EMPTY todas as buscas vindas do repository,
        //pois se em algum momento não trazer dados vai da erro de posição inacessível do array.       
        
        //Busca Desconto baseado no modo e no local de processamento.
        if (!empty($tabelaPrecos)) {
            if ($modoLocal == 'FF') {
                if (is_null($tabelaPrecos[0]['VRPEDESFILIFILI']) || $tabelaPrecos[0]['VRPEDESFILIFILI'] == '') {
                    $descModoLocal = 1;
                } else {
                    $descModoLocal = (100 - $tabelaPrecos[0]['VRPEDESFILIFILI']) / 100;
                }
            } elseif ($modoLocal == 'FM') {
                if (is_null($tabelaPrecos[0]['VRPEDESFILIMATR']) || $tabelaPrecos[0]['VRPEDESFILIMATR'] == '') {
                    $descModoLocal = 1;
                } else {
                    $descModoLocal = (100 - $tabelaPrecos[0]['VRPEDESFILIMATR']) / 100;
                }
            } elseif ($modoLocal == 'MM') {
                $descModoLocal = 1;
            }
            $vrPerManuAno = $tabelaPrecos[0]['VRPERCMANUTANO'];
            $nrMesPraLoca = $tabelaPrecos[0]['NRMESPRAZOLOCA'];
            $vrUnit = $tabelaPrecos[0]['VRPRECOUNITSIST'];
        }

        //Desconto Qt. Sistemas -- str_pad -> preencher com 0
        $descSistAte = Sistprecoprop::getRepository()->getDescSistemasAte($cdPreco, str_pad($qtSistemas, 5, '0', STR_PAD_LEFT));
        $descSist    = Sistprecoprop::getRepository()->getDescSistemas($cdPreco, str_pad($qtSistemas, 5, '0', STR_PAD_LEFT));

        //Desconto Qt. Usuários
        $descUsurAte = Usuprecoprop::getRepository()->getDescUsuariosAte($cdPreco, str_pad($qtUsuarios, 5, '0', STR_PAD_LEFT));
        $descUsur    = Usuprecoprop::getRepository()->getDescUsuarios($cdPreco, str_pad($qtUsuarios, 5, '0', STR_PAD_LEFT));

        $nmIndice = '';
        $vrIndice = '';
        $dtIndice = '';

        /*
         * Início: Phillipe Silva - 02/10/14
         * Não será mais considerada a multiplicação pelo BTN para para os produtos comerciais selecionados
         */

        $config       = Config::getInstance();
        $stTabPreco   = 'getPcotabprecoProduto'.$prodComercial.'Btn';
        $tabPrecosBtn = 'true';

        try {
            $tabPrecosBtn = $config->{$stTabPreco}();
        } catch(\Exception $e){}

        if (($idTipo == 'P') || ($idTipo == 'A') || $tabPrecosBtn == 'false') {
            $indice = 1;
        } else {
            //Valor do Índice
            $valorIndice = Precoproposta::getRepository()->getValorIndice();

            if (!empty($valorIndice)) {
                if (is_null($valorIndice[0]['VRINDICE']) || $valorIndice[0]['VRINDICE'] == '') {
                    $indice = 1;
                } else {
                    $indice = $valorIndice[0]['VRINDICE'];
                }

                $nmIndice = $valorIndice[0]['SGINDICE'] . ' - ' . $valorIndice[0]['NMINDICE'];
                $vrIndice = $valorIndice[0]['VRINDICE'];
                $dtIndice = $valorIndice[0]['DTREFIND'];
            }
        }

        /*
         * Fim: Phillipe Silva - 02/10/14
         */

        //--------------------------------->CÁLCULOS
        //1: Calcula valor $licencaUso baseado na Qt. Sistemas.            
        $vrAux = $licencaUso = 0;

        if (!empty($descSistAte)) {
            foreach ($descSistAte as $Sistema) {
                $desconto  = $Sistema['VRPERCDESCSIST'];
                $qtFinal   = $Sistema['QTFINSISTEMAS'];
                $qtInicial = $Sistema['QTINISISTEMAS'];

                if ($desconto > 0) {
                    $vrAux = $vrAux + (($qtFinal - $qtInicial + 1) * $vrUnit) - ((($qtFinal - $qtInicial + 1) * $vrUnit) * $desconto / 100);
                } else {
                    $vrAux = $vrAux + (($qtFinal - $qtInicial + 1) * $vrUnit);
                }
            }
        }

        if (!empty($descSist)) {
            $qtIncial_fim = $descSist[0]['QTINISISTEMAS'];
            $desconto_fim = $descSist[0]['VRPERCDESCSIST'];

            if ($desconto_fim > 0) {
                $licencaUso = (($qtSistemas - $qtIncial_fim + 1) * $vrUnit) - ((($qtSistemas - $qtIncial_fim + 1) * $vrUnit) * $desconto_fim / 100);
            } else {
                $licencaUso = ($qtSistemas - $qtIncial_fim + 1) * $vrUnit;
            }
        }

        $licencaUso += $vrAux;

        //2: Calcula valor $licencaUso2 baseado na Qt. Usuarios.
        $vrAux2 = $licencaUso2 = 0;

        if (!empty($descUsurAte)) {
            foreach ($descUsurAte as $Usuario) {
                $qtFinalUsu   = $Usuario['QTFINUSUARIOS'];
                $qtInicialUsu = $Usuario['QTINIUSUARIOS'];
                $descontoUsu  = $Usuario['VRPERCDESCUSU'];

                if ($descontoUsu > 0) {
                    $vrAux2 = $vrAux2 + (($qtFinalUsu - $qtInicialUsu + 1) * $vrUnit) * $descontoUsu / 100;
                }
            }
        }

        if (!empty($descUsur)) {
            $qtIncialUsu_fim = $descUsur[0]['QTINIUSUARIOS'];
            $descontoUsu_fim = $descUsur[0]['VRPERCDESCUSU'];

            if ($descontoUsu_fim > 0) {
                $licencaUso2 = (($nrUsuarios - $qtIncialUsu_fim + 1) * $vrUnit) - ((($nrUsuarios - $qtIncialUsu_fim + 1) * $vrUnit) * $descontoUsu_fim / 100);
            }
        }

        $licencaUso2 += $vrAux2;

        //3: Calcula valores da Licença, Manutençao e Locação referentes a uma Única Licença.
        if ($modoLocal == 'FM') {
            //Valores para o Tipo FM.
            $licencaFinal = $vrUnit       * $indice       * $descModoLocal;
            $manutencao   = $licencaFinal * $vrPerManuAno / 12 / 100;
            $locacao      = $licencaFinal / $nrMesPraLoca + $manutencao;
        } else {
            //Valores para o Tipo MM e FF.
            $licencaFinal = ($licencaUso  + $licencaUso2) * $indice * $descModoLocal;
            $manutencao   = $licencaFinal * $vrPerManuAno / 12 / 100;
            $locacao      = $licencaFinal / $nrMesPraLoca + $manutencao;
        }

        $dados = array('VRLICENCUSOPROP' => $licencaFinal,
                       'VRMENSALIDAPROP' => $manutencao,
                             'VRLOCACAO' => $locacao,
                              'NMINDICE' => $nmIndice,
                              'DTREFIND' => $dtIndice,
                              'VRINDICE' => $vrIndice);

        return $dados;
    }
    
    public static function incluirValoresLinhaProduto($nrorg, $proposta, $versao, $cdlinpprop, $vrLicensa, $vrMensalid, $vrLocacao, $idTipo, $cdPreco, $vrDesLicUso, $vdDesMensal)
    {
        $linha = Propostalinp::findOneByNrproposfasAndNrverpropfasAndCdlinppropAndNrorg($proposta, $versao, $cdlinpprop, $nrorg);
        $manager = \Setforms2\Shared\Registry::getEntityManager();

        if(is_object($linha))
        {
            //Produto Manutenção
            if($idTipo == 'M')
            {
                $linha->setVrlicencusoprop($vrLicensa);
                $linha->setVrmensalidaprop($vrMensalid);
                $linha->setVrlicencusotabe($vrLicensa);
                $linha->setVrmensalidatabe($vrMensalid);
                $linha->setVrdeslicusoprop($vrDesLicUso);
                $linha->setVrdesmensalprop($vdDesMensal);

            }
            //Produto Locação
            elseif($idTipo == 'L')
            {
                $linha->setVrmensalidaprop($vrLocacao);
                $linha->setVrmensalidatabe($vrLocacao);
                $linha->setVrdesmensalprop($vdDesMensal);
            }
            //Pto. Acesso Manutenção
            elseif($idTipo == 'P')
            {
                $linha->setVrlusopropptoa($vrLicensa);
                $linha->setVrmenspropptoa($vrMensalid);
                $linha->setVrlicencusotabe($vrLicensa);
                $linha->setVrmensalidatabe($vrMensalid);
                $linha->setVrdeslicusoprop($vrDesLicUso);
                $linha->setVrdesmensalprop($vdDesMensal);
            }
            //Pto. Acesso Locação
            elseif($idTipo == 'A')
            {
                $linha->setVrmenspropptoa($vrLocacao);
                $linha->setVrmensalidatabe($vrLocacao);
                $linha->setVrdesmensalprop($vdDesMensal);
            }
            
            $linha->setCdprecoprop($cdPreco);
            $linha->setIdtppgtlinpp('F');
            $linha->setIdamblinpp('WEB');
            
            $linha->persist();

            $manager->flush();
        }
    }
    
    public static function geraParcelasAction($nrProposta, $nrVersao, $qtParc, $dtVenc, $nrOrg)
    {
        $linhasProduto = Propostalinp::findByNrproposfasAndNrverpropfasAndNrorg($nrProposta, $nrVersao, $nrOrg);
        
        $txJuros = ParGeralFas::findOneByNrorg($nrOrg);
        $taxa    = $txJuros->getVrtxjuroslicuso();
        
        //Qt. Max. de Parcelas sem Juros = 3
        if($qtParc > 3){
            $txJuros = $taxa;
        }else{
            $txJuros = 0;
        }
        
        foreach($linhasProduto as $linha) {     
            $vrTotal = self::getVrTotalLinhaProduto($nrProposta, $nrVersao, $linha->getCdlinpprop(), $linha->getIdtiplinpp());
            if($vrTotal > 0) {
                Facade011::geraParcelas($vrTotal, $dtVenc, $qtParc, $txJuros, $linha->getCdlinpprop(), 'NOT RELOAD');
            }
        }
    }
    
    public static function getVrTotalLinhaProduto($nrProposta, $nrVersao, $cdlinprop, $idTipLinpp)
    {
        $propostaLinp = Propostalinp::findOneByNrproposfasAndNrverpropfasAndCdlinpprop($nrProposta, $nrVersao, $cdlinprop);
        $vrTotal = 0;
        
        switch($idTipLinpp) {
            case self::PROD_MANUTENCAO:
                if($propostaLinp->getVrlicencusoprop()) {
                    $vrTotal = ($propostaLinp->getVrlicencusoprop() - $propostaLinp->getVrdeslicusoprop()) * $propostaLinp->getQtminimafatprop();
                }
                break;
            case self::PROD_LOCACAO:
                 if($propostaLinp->getVrmensalidaprop()) {
                    $vrTotal = ($propostaLinp->getVrmensalidaprop() - $propostaLinp->getVrdesmensalprop()) * $propostaLinp->getQtminimafatprop();
                }
                break;
            case self::PTO_MANUTENCAO:
                 if($propostaLinp->getVrlusopropptoa()) {
                    $vrTotal = ($propostaLinp->getVrlusopropptoa() - $propostaLinp->getVrdlusopropptoa()) * $propostaLinp->getQtminimafatprop();
                }
                break;
            case self::PTO_LOCACAO:
                 if($propostaLinp->getVrmespropptoa()) {
                    $vrTotal = ($propostaLinp->getVrmespropptoa() - $propostaLinp->getVrdmespropptoa()) * $propostaLinp->getQtminimafatprop();
                }
                break;
            default:
                $vrTotal = 0;
                break;
        }
        
        return $vrTotal;
    }
    
    public static function setDatasCarenciaLinhasProd($dataCarencia, $nrProposta, $nrVersao, $nrOrg)
    {
        $entityManager = Registry::getEntityManager();
        $db = $entityManager->getConnection();
        $db->beginTransaction();
        
        try{
            $linhasProduto = Propostalinp::findByNrproposfasAndNrverpropfasAndNrorg($nrProposta, $nrVersao, $nrOrg);
            
            foreach($linhasProduto as $linha) {
                if(is_object($linha)) {
                    $linha->setDtcaluslinpp($dataCarencia);
                    $linha->persist();
                }
            }
            
            $entityManager->flush();
            $db->commit();
        } catch (\Exception $e) {
            $db->rollback();
            throw $e;
        }        
    }
    
    public static function setValorDefaultCarenciaLP($nrProposta, $nrVersao, $dtProposta, $cdLinpProp, $nrOrg)
    {
        $dtCarencia = DateUtil::getUltimoDiaDoMes(DateUtil::getDataDeString($dtProposta, DateUtil::FORMATO_BRASILEIRO_DATAHORA, true));        
        $propLinp   = Propostalinp::findOneByNrproposfasAndNrverpropfasAndCdlinppropAndNrorg($nrProposta, $nrVersao, $cdLinpProp, $nrOrg);
        
        if(is_object($propLinp)) {
            $propLinp->setDtcaluslinpp($dtCarencia);
            $propLinp->persist();

            Registry::getEntityManager()->flush();
        }
    }
    
    public static function returnBoolValoresLP($idTipoLP, $nrProposta, $nrVersao, $cdLinpProp, $nrOrg)
    {
        $propLinp = Propostalinp::findOneByNrproposfasAndNrverpropfasAndCdlinppropAndNrorg($nrProposta, $nrVersao, $cdLinpProp, $nrOrg);
        
       if ($idTipoLP == 'M' || $idTipoLP == 'L') {
            if (($propLinp->getVrlicencusoprop() != 0 && $propLinp->getVrlicencusoprop() != null) ||
                ($propLinp->getVrmensalidaprop() != 0 && $propLinp->getVrmensalidaprop() != null)) {
                return true;
            }
        } else if ($idTipoLP == 'P' || $idTipoLP == 'A') {
            if (($propLinp->getVrlusopropptoa() != 0 && $propLinp->getVrlusopropptoa() != null) ||
                ($propLinp->getVrmenspropptoa() != 0 && $propLinp->getVrmenspropptoa() != null)) {
                return true;
            }
        }

        return false;
    }
    
    public static function returnBoolExistsLP($nrProposta, $nrVersao, $cdLinpProp, $nrOrg)
    {
        $propLinp = Propostalinp::findOneByNrproposfasAndNrverpropfasAndCdlinppropAndNrorg($nrProposta, $nrVersao, $cdLinpProp, $nrOrg);
        
        if(is_object($propLinp)) {
            return true;
        }
        
        return false;
    }

    public static function deleteSistemasLinhaProduto($nrProposta, $nrVersao, $cdLinpProp, $nrOrg)
    {
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();

        try{
            $sistproplinp = Sistproplinp::findByNrproposfasAndNrverpropfasAndCdlinppropAndNrorg($nrProposta, $nrVersao, $cdLinpProp, $nrOrg);

            foreach ($sistproplinp as $sistema) {
                $sistema->delete();
            }

            $connection->flush();
            $db->getConn()->commit();

        } catch(\Exception $e) {
            $db->getConn()->rollback();
            throw $e;
        }
    }

    public static function getCdPrecoPropLP($nrProposta, $nrVersao, $cdLinpProp)
    {
        $propostaLinp = Propostalinp::findOneByNrproposfasAndNrverpropfasAndCdlinpprop($nrProposta, $nrVersao, $cdLinpProp);

        if(is_object($propostaLinp)) {
            return $propostaLinp->getCdprecoprop();
        }

        return false;
    }

    public static function getLinhaProdutoSemPreco($nrProposta, $nrVersao)
    {
        $propLinp = Propostalinp::findByNrproposfasAndNrverpropfas($nrProposta, $nrVersao);
        $linhas   = array();

        foreach($propLinp as $linhaProd) {
            if(!$linhaProd->getCdprecoprop()) {
                $linhas[] = $linhaProd->getNmlinpprop();
            }
        }

        return $linhas;
    }
}